<template>
    <CCard>
        <CCardHeader>
            <CButton block class="btn-link shadow-none font-weight-bold text-black-50" @click="formToggle">
                СОЗДАНИЕ НОВОГО ЗАКАЗА
            </CButton>
        </CCardHeader>
        <CCardBody class="mx-md-5">
            <CForm class="position-relative mb-2">
                <CCollapse :show="formShow">
                    <CRow>
                        <CCol sm="4">
                            <div role="group" class="form-group">
                                <label for="platforms">
                                    Поставщик
                                </label>
                                <div class="w-100">
                                    <multiselect
                                        v-model="orderData.supplier"
                                        :options="supplierList"
                                        track-by="name"
                                        label="name"
                                        placeholder="Выберите..."
                                        selectLabel=""
                                        selectGroupLabel=""
                                        selectedLabel=""
                                        deselectLabel=""
                                        deselectGroupLabel=""
                                        tagPlaceholder=""
                                        @select="supplierChange"
                                    />
                                </div>
                            </div>
                        </CCol>
                        <CCol sm="4">
                            <CInput
                                label="Логистическое плечо, поставщика"
                                v-model="orderData.logisticShoulder"
                                disabled
                            />
                        </CCol>
                        <CCol sm="4">
                            <div role="group" class="form-group">
                                <label for="platforms">
                                    Дата следующего заказа – товары А
                                </label>
                                <DatePicker class="w-100" v-model="orderData.dateA" />
                            </div>
                        </CCol>
                    </CRow>
                    <CRow>
                        <CCol sm="4">
                            <div role="group" class="form-group">
                                <label for="platforms">
                                    Юридическое лицо Сити
                                </label>
                                <div class="w-100">
                                    <multiselect
                                        v-model="orderData.ulCity"
                                        :options="ulCityList"
                                        track-by="name"
                                        label="name"
                                        placeholder="Выберите..."
                                        selectLabel=""
                                        selectGroupLabel=""
                                        selectedLabel=""
                                        deselectLabel=""
                                        deselectGroupLabel=""
                                        tagPlaceholder=""
                                    />
                                </div>
                            </div>
                        </CCol>
                        <CCol sm="4">
                            <CInput
                                label="Минимальная сумма заказа"
                                v-model="orderData.minOrderPrice"
                                disabled
                            />
                        </CCol>
                        <CCol sm="4">
                            <div role="group" class="form-group">
                                <label for="platforms">
                                    Дата следующего заказа – товары В
                                </label>
                                <DatePicker class="w-100" v-model="orderData.dateB" />
                            </div>
                        </CCol>
                    </CRow>
                    <CRow>
                        <CCol sm="4">
                            <div role="group" class="form-group">
                                <label for="platforms">Площадка</label>
                                <div class="w-100">
                                    <CButtonGroup id="platforms" class="btn-group-toggle w-100 text-left">
                                        <label
                                            :class="['btn btn-outline-secondary', {active: allPlatforms}]"
                                            for="checkbox-allPlatforms"
                                        >
                                            <input
                                                id="checkbox-allPlatforms"
                                                type="checkbox"
                                                :value="allPlatforms"
                                                :checked="allPlatforms"
                                                name="platforms"
                                                autocomplete="off"
                                                :aria-pressed="!!allPlatforms"
                                                :class="{active: allPlatforms}"
                                                @click="selectAllPlatforms"
                                            >
                                            Все
                                        </label>
                                        <label
                                            v-for="(platform, index) in platformList"
                                            :key= index
                                            :class="['btn btn-outline-secondary', {active: orderData.platforms.includes(platform)}]"
                                            :for="`checkbox-${platform}`"
                                        >
                                            <input
                                                :id="`checkbox-${platform}`"
                                                :value="platform"
                                                type="checkbox"
                                                :checked="orderData.platforms.includes(platform)"
                                                name="platforms"
                                                autocomplete="off"
                                                :aria-pressed="orderData.platforms.includes(platform)"
                                                v-model="orderData.platforms"
                                            >
                                            {{ platform }}
                                        </label>
                                    </CButtonGroup>
                                </div>
                            </div>
                        </CCol>
                        <CCol sm="4">
                            <CInput
                                label="Сумма заказа"
                                v-model="totalPrice"
                                type="number"
                            />
                        </CCol>
                        <CCol sm="4">
                            <div role="group" class="form-group">
                                <label for="platforms">
                                    Дата следующего заказа – товары С
                                </label>
                                <DatePicker class="w-100" v-model="orderData.dateC" />
                            </div>
                        </CCol>
                    </CRow>
                </CCollapse>
                <CRow class="mt-4">
                    <CCol sm="3">
                            <CButton
                                type="submit"
                                color="success"
                                block
                                class="mb-2"
                                @click.prevent="saveOrder"
                            >
                                Сохранить
                            </CButton>
                    </CCol>
                    <CCol sm="4">
                        <CButton
                            color="success"
                            variant="outline"
                            block
                            class="mb-2"
                            @click.prevent="calculate"
                        >
                            Рассчитать рекомендации
                        </CButton>
                    </CCol>
                </CRow>
            </CForm>
        </CCardBody>
    </CCard>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
    name: "OrderCreateInfo",
    data() {
        return {
            orderData: {
                supplier: null,
                minOrderPrice: 0,
                logisticShoulder: 0,
                ulCity: null,
                totalPrice: 0,
                platforms: [],
                dateA: null,
                dateB: null,
                dateC: null,
            },
            formShow: true,
            platformList: ['WB', 'OZON'],
            orderId: null,
        };
    },
    mounted() {
        this.getLegalEntities()
        this.getSuppliers()
    },
    computed: {
        ulCityList() { // Список юр лиц
            return this.$store.getters.legalEntities
        },
        supplierList() { // Список поставщиков
            return this.$store.getters.suppliers
                ? this.$store.getters.suppliers.rest_suppliers
                : null
        },
        allPlatforms() { // Список торговых площадок
            return this.orderData.platforms.length === this.platformList.length
        },
        ...mapGetters({getEditedProducts: 'getEditedProducts', totalPrice: 'getTotalPrice'})
    },
    methods: {
        getLegalEntities() { // Получение списка юр лиц
            this.$store.dispatch('getLegalEntities')
        },
        supplierChange(value) { // Изменение поставщика
            this.orderData.supplier = value
            const {min_order_price, suppliers_logistics_leverage} = value
            this.orderData.minOrderPrice = min_order_price
            this.orderData.logisticShoulder = suppliers_logistics_leverage
        },
        getSuppliers() { // Получение списка поставщиков
            this.$store.dispatch('getSuppliers')
        },
        formToggle() { // Скрытие и раскрытие формы
            this.formShow = !this.formShow
        },
        selectAllPlatforms() { // Выбрать все платформы
            if (this.allPlatforms) {
                this.orderData.platforms = []
            } else {
                this.$set(this.orderData, 'platforms', this.platformList)
                this.orderData.platforms = this.platformList
            }
        },
        calculate() { // Рассчитать рекомендации
            const platforms = []
            if (this.orderData.platforms.includes('WB')) platforms.push('1')
            if (this.orderData.platforms.includes('OZON')) platforms.push('2')

            this.changePreloaderState(true, 'Расчет рекомендаций');
            this.$store.dispatch('getRecommendations', {
                "supplier_id": this.orderData.supplier ? this.orderData.supplier.id : null,
                "legal_entity_id": this.orderData.ulCity ? this.orderData.ulCity.id : null,
                "next_order_date": this.orderData.dateA ? this.orderData.dateA[0]: null,
                "next_order_date_a": this.orderData.dateA || null,
                "next_order_date_b": this.orderData.dateB || null,
                "next_order_date_c": this.orderData.dateC || null,
                platforms,
            })
            .then((response) => {
                this.$emit('getRecommendations')
                if (response.data.notifications && response.data.notifications.message)
                    this.$store.dispatch('toast/addToast', {
                        toastInfo: response.data.notifications.message,
                        isVisibleToast: true,
                        type: 'success'
                    })
            })
            .catch(error => {
                const errors = error.response.data.data.errors
                Object.values(errors).forEach(item => {
                    item.forEach(message => {
                        this.$store.dispatch('toast/addToast', {
                            toastInfo: message,
                            isVisibleToast: 1,
                        })
                    })
                })
            })
            .finally(() => this.changePreloaderState(false, ''))

        },
        saveOrder() { //Сохранение заказа
            this.changePreloaderState(true, 'Сохранение заказа');

            const platforms = []
            if (this.orderData.platforms.includes('WB')) platforms.push('1')
            if (this.orderData.platforms.includes('OZON')) platforms.push('2')
            this.$store.dispatch('saveOrder', {
                "supplier_id": this.orderData.supplier ? this.orderData.supplier.id : null,
                "legal_entity_id": this.orderData.ulCity ? this.orderData.ulCity.id : null,
                "next_order_date": this.orderData.dateA ? this.orderData.dateA[0]: null,
                "next_order_date_a": this.orderData.dateA || null,
                "next_order_date_b": this.orderData.dateB || null,
                "next_order_date_c": this.orderData.dateC || null,
                platforms,
                products: this.getEditedProducts.map(item => ({...item, product_id: item.id}))
            })
            .finally(() => this.changePreloaderState(false, ''))

        }
    },
};
</script>
